﻿using System.Collections.Generic;
using Hi.Geom;
using Hi.Mech.Topo;

namespace Sample.Geom
{
    /// <remarks>
    /// ### Source Code
    /// [!code-csharp[SampleCode](~/../Hi.Sample/Geom/DemoBuildGeom.cs)]
    /// </remarks>
    public static class DemoBuildGeom
    {
        public static List<IGetStl> GenGeoms()
        {
            Box3d box = new Box3d(0, 0, -50, 70, 50, 0);
            Cylindroid cylindroid = new Cylindroid()
            {
                PairZrs = new List<PairZr>([ new PairZr(0,12),new PairZr(20,12),
                                new PairZr(20,16),new PairZr(30,16)]),
                LongitudeNum = 30
            };
            Stl stl = new Stl("geom.stl");
            TransformationGeom transformationGeom = new TransformationGeom()
            {
                Transformer = new GeneralTransform(1,
                    new StaticRotation(new Vec3d(0, 0, 1), MathUtil.ToRad(15), new Vec3d(0, 0, 0)),
                    new StaticTranslation(new Vec3d(0, 0, 0))),
                Geom = stl
            };
            return new List<IGetStl>([box, cylindroid, stl, transformationGeom]);
        }
    }
}
